Index: trunk/VUT/work/README_ONLINE.txt
===================================================================
--- trunk/VUT/work/README_ONLINE.txt	(revision 210)
+++ trunk/VUT/work/README_ONLINE.txt	(revision 226)
@@ -6,10 +6,16 @@
    Ogre 1.03 for vs 7.1
    Ogre Dependencies
-   
+   svn
+
+2) check out gametools repository
+   in the following it is assumed that your repository is located in D:\gametools (not required, just replace your path)
+
+   the current stable version is located in D:\gametools
+
 2) add following environment variables:
    OGRE_PATH: directory where ogre.sln is located
    GAMETOOLS_PATH: directory where the gametools repository is located (e.g., d:\gametools)
 
-3) copy VUT/work/ogre_changes into OGRE_PATH directory
+3) copy VUT\work\ogre_changes into OGRE_PATH directory
 
 4) Set configuration of Ogre soluation to release. add preprocessor flag GTP_VISIBILITY_MODIFIED_OGRE to following projects:
@@ -21,17 +27,19 @@
    example projects
 
-5) Add following resources to OGRE_PATH/Samples/Common/bin/Release/resource.cfg (if your repository is located in D:/gametools):
+5) Add following resources to OGRE_PATH\Samples\Common\bin\Release\resource.cfg:
 
-   FileSystem=D:/gametools/trunk/VUT/Ogre/resources/materials/scripts
-   FileSystem=D:/gametools/trunk/VUT/Ogre/resources/materials/textures
-   FileSystem=D:/gametools/trunk/VUT/Ogre/resources/models
-   FileSystem=D:/gametools/trunk/VUT/Ogre/resources/models/trees
-   FileSystem=D:/gametools/trunk/VUT/Ogre/resources/overlays
-   FileSystem=D:/gametools/trunk/VUT/Ogre/resources/media
+   FileSystem=D:\gametools\trunk\VUT\Ogre\resources\materials\scripts
+   FileSystem=D:\gametools\trunk\VUT\Ogre\resources\materials\textures
+   FileSystem=D:\gametools\trunk\VUT\Ogre\resources\models
+   FileSystem=D:\gametools\trunk\VUT\Ogre\resources\models\trees
+   FileSystem=D:\gametools\trunk\VUT\Ogre\resources\overlays
+   FileSystem=D:\gametools\trunk\VUT\Ogre\resources\media
 
-6) Add Plugin_VisibilitySceneManager to OGRE_PATH/Samples/Common/bin/Release/Plugins.cfg
+6) Add Plugin_VisibilitySceneManager to OGRE_PATH\Samples\Common\bin\Release\Plugins.cfg
    and comment out OctreeSceneManager
 
-7) Copy D:\gametools\trunk\VUT\Ogre\resources/terrain.cfg into OGRE_PATH/Samples/Common/bin/Release
+7) Copy D:\gametools\trunk\VUT\Ogre\resources\terrain.cfg into OGRE_PATH\Samples\Common\bin\Release
 
-8) start TestCullingTerrain.exe
+8) open scripts\GtpVisibility.sln and compile all
+
+9) start TerrainExampleApplication for testing
Index: trunk/VUT/work/TestCullingTerrain/TestCullingTerrain.vcproj
===================================================================
--- trunk/VUT/work/TestCullingTerrain/TestCullingTerrain.vcproj	(revision 187)
+++ trunk/VUT/work/TestCullingTerrain/TestCullingTerrain.vcproj	(revision 226)
@@ -38,5 +38,5 @@
 				OutputFile="$(OGRE_PATH)/Samples/Common/bin/Debug/TestCullingTerrain.exe"
 				LinkIncremental="2"
-				AdditionalLibraryDirectories="&quot;$(OGRE_PATH)\Dependencies\Lib\$(ConfigurationName)&quot;;&quot;$(OGRE_ADDONS_PATH)\dotsceneoctree\PlugIns\DotSceneManager\bin\$(ConfigurationName)&quot;;&quot;$(GAMETOOLS_PATH)\trunk\VUT\Ogre\lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\OgreMain\Lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\bin\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\lib&quot;"
+				AdditionalLibraryDirectories="&quot;$(OGRE_PATH)\Dependencies\Lib\$(ConfigurationName)&quot;;&quot;$(OGRE_ADDONS_PATH)\dotsceneoctree\PlugIns\DotSceneManager\bin\$(ConfigurationName)&quot;;&quot;..\Ogre\lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\OgreMain\Lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\bin\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\lib&quot;"
 				GenerateDebugInformation="TRUE"
 				ProgramDatabaseFile="$(OutDir)/TestCullingTerrain.pdb"
@@ -88,5 +88,5 @@
 				OutputFile="$(OGRE_PATH)/Samples/Common/bin/Release/TestCullingTerrain.exe"
 				LinkIncremental="1"
-				AdditionalLibraryDirectories="&quot;$(OGRE_PATH)\Dependencies\Lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\OgreMain\Lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\bin\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\lib&quot;;&quot;$(GAMETOOLS_PATH)\trunk\VUT\Ogre\lib\$(ConfigurationName)&quot;"
+				AdditionalLibraryDirectories="&quot;$(OGRE_PATH)\Dependencies\Lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\OgreMain\Lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\bin\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\lib&quot;;&quot;..\..\Ogre\lib\$(ConfigurationName)&quot;"
 				GenerateDebugInformation="TRUE"
 				SubSystem="2"
Index: trunk/VUT/work/TestCulling/TestCulling.vcproj
===================================================================
--- trunk/VUT/work/TestCulling/TestCulling.vcproj	(revision 136)
+++ trunk/VUT/work/TestCulling/TestCulling.vcproj	(revision 226)
@@ -87,5 +87,5 @@
 				OutputFile="$(OGRE_PATH)/Samples/Common/bin/Release/TestCulling.exe"
 				LinkIncremental="1"
-				AdditionalLibraryDirectories="&quot;$(OGRE_PATH)\Dependencies\Lib\$(ConfigurationName)&quot;;&quot;$(OGRE_ADDONS_PATH)\dotsceneoctree\PlugIns\DotSceneManager\bin\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\OgreMain\Lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\bin\$(ConfigurationName)&quot;;&quot;$(GAMETOOLS_PATH)\trunk\VUT\Ogre\lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\lib&quot;"
+				AdditionalLibraryDirectories="&quot;$(OGRE_PATH)\Dependencies\Lib\$(ConfigurationName)&quot;;&quot;$(OGRE_ADDONS_PATH)\dotsceneoctree\PlugIns\DotSceneManager\bin\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\OgreMain\Lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\bin\$(ConfigurationName)&quot;;&quot;..\..\Ogre\lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\lib&quot;"
 				GenerateDebugInformation="TRUE"
 				SubSystem="2"
Index: trunk/VUT/work/iv/Demo_IV.vcproj
===================================================================
--- trunk/VUT/work/iv/Demo_IV.vcproj	(revision 193)
+++ trunk/VUT/work/iv/Demo_IV.vcproj	(revision 226)
@@ -46,5 +46,5 @@
 				LinkIncremental="1"
 				SuppressStartupBanner="TRUE"
-				AdditionalLibraryDirectories="&quot;$(OGRE_PATH)\OgreMain\Lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\lib&quot;;&quot;..\IVReader\Lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\Dependencies\Lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\bin\$(ConfigurationName)&quot;;&quot;$(GAMETOOLS_PATH)\trunk\VUT\Ogre\lib\$(ConfigurationName)&quot;"
+				AdditionalLibraryDirectories="&quot;$(OGRE_PATH)\OgreMain\Lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\lib&quot;;&quot;..\IVReader\Lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\Dependencies\Lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\bin\$(ConfigurationName)&quot;;&quot;..\..\Ogre\lib\$(ConfigurationName)&quot;"
 				ProgramDatabaseFile=".\..\bin\Release/Demo_IV.pdb"
 				SubSystem="2"